import { EventEmitter } from "./event-emitter";
import { Mesh } from "./mesh";
import { PairingItem, PairingRecord, PeerRecord, RoomRecord } from "./records";
export declare abstract class BaseSignaling {
    protected _uuid: string;
    protected roomRecord: RoomRecord | null;
    protected _roomRecordEmitter: EventEmitter<RoomRecord>;
    protected pairingMap: Map<string, PairingItem>;
    protected _autoclean: boolean;
    get roomRecordEmitter(): EventEmitter<RoomRecord>;
    get uuid(): string;
    get autoclean(): boolean;
    set autoclean(value: boolean);
    constructor();
    hostRoom(roomId: string, username: string, uuid: string): Promise<boolean>;
    joinRoom(roomId: string, username: string, uuid: string): Promise<boolean>;
    protected abstract internalHostRoom(roomId: string, username: string): Promise<boolean>;
    protected abstract internalJoinRoom(roomId: string, username: string): Promise<boolean>;
    protected abstract saveRoomInfo(): void;
    protected abstract saveIceCandidate(uuid: string, candidate: string): void;
    protected abstract savePairing(mesh: Mesh, myIndex: number, index: number, peer: PeerRecord): void;
    protected abstract savePairingRecord(info: PairingRecord, uuid: string): void;
    protected abstract cleanup(): void;
    upatePlayerStatus(ready: boolean): void;
    protected roomRecordChanged(info: RoomRecord, roomId: string, username: string, uuid: string): void;
    startPairings(mesh: Mesh): Promise<boolean>;
    newPairings(mesh: Mesh): Promise<string>;
    protected pairingRecordChanged(mesh: Mesh, info: PairingRecord, peer: PeerRecord, myIndex: number, index: number): void;
}
