import { BaseSignaling } from '../base-signaling';
import { Mesh } from '../mesh';
import { PeerRecord, PairingRecord } from '../records';
export declare class DeepstreamSignaling extends BaseSignaling {
    private deepstreamClient;
    private room;
    private subscriptions;
    private pairRecordMap;
    constructor(deepstreamUrl: string);
    protected cleanup(): void;
    private bindRoom;
    protected internalHostRoom(roomId: string, username: string): Promise<boolean>;
    protected internalJoinRoom(roomId: string, username: string): Promise<boolean>;
    protected saveRoomInfo(): void;
    protected saveIceCandidate(uuid: string, candidate: string): void;
    protected savePairing(mesh: Mesh, myIndex: number, index: number, peer: PeerRecord): void;
    protected savePairingRecord(info: PairingRecord, uuid: string): void;
}
