import { EventEmitter } from './event-emitter';
import { MeshConfig } from './mesh-config';
import { Message } from './message';
export declare class MeshConnection {
    private config;
    private _uuid;
    private static SYSTEM_CHANNEL_LABEL;
    private static APP_CHANNEL_LABEL;
    private _connection;
    private _channel;
    private _systemChannel;
    private _connectionReady;
    private _connectionReadyEmitter;
    private _connectionNotReadyNotified;
    private _iceCandidateEmitter;
    private _messageEmitter;
    private _systemMessageEmitter;
    private _messageSeq;
    private _messagesAwaitingReply;
    private _messagesAwaitingReplyCount;
    private _messagesAwaitingReplyCleanerTimer;
    private _latency;
    private _minLatency;
    private _clockDiff;
    private _checkLatencyIntervalTimer;
    constructor(config: MeshConfig, _uuid: string);
    addIceCandidate(candidate: RTCIceCandidateInit): void;
    get uuid(): string;
    get connectionReadyEmitter(): EventEmitter<boolean>;
    get iceCandidateEmitter(): EventEmitter<RTCIceCandidate>;
    get messageEmitter(): EventEmitter<Message>;
    get systemMessageEmitter(): EventEmitter<Message>;
    get isOpen(): boolean;
    get latency(): number | undefined;
    get clockDiff(): number | undefined;
    close(): void;
    createOffer(): Promise<RTCSessionDescriptionInit>;
    createAnswer(offer: RTCSessionDescriptionInit): Promise<RTCSessionDescriptionInit>;
    verifyAnswer(answer: RTCSessionDescriptionInit): Promise<void>;
    private updateLatencyAndClockDiff;
    private connectionReadyTasks;
    private sendPing;
    private emitConnectionIsNotReady;
    private cleanMessagesAwaitingReply;
    private storeMessagesAwaitingReply;
    private processReceivedMessage;
    private internalSend;
    private sendByChannel;
    private sendAndListenBychannel;
    private replyByChannel;
    private replyAndListenByChannel;
    send(message: ArrayBuffer): boolean;
    sendSys(message: ArrayBuffer): boolean;
    sendAndListen(message: ArrayBuffer): Promise<Message>;
    sendAndListenSys(message: ArrayBuffer): Promise<Message>;
    reply(originalMessage: Message, message: ArrayBuffer): boolean;
    replySys(originalMessage: Message, message: ArrayBuffer): boolean;
    replyAndListen(originalMessage: Message, message: ArrayBuffer): Promise<Message>;
    replyAndListenSys(originalMessage: Message, message: ArrayBuffer): Promise<Message>;
}
