import { EventEmitter } from './event-emitter';
import { MeshConfig } from './mesh-config';
import { Message } from './message';
export declare class Mesh {
    private config;
    private _uuid;
    private _connections;
    private _meshReadyEmitter;
    private _connectionReadyEmitter;
    private _iceCandidateEmitter;
    private _messageEmitter;
    private _peerReadyCount;
    constructor(config: MeshConfig, _uuid: string);
    get uuid(): string;
    get meshReadyEmitter(): EventEmitter<boolean>;
    get connectionReadyEmitter(): EventEmitter<boolean>;
    get iceCandidateEmitter(): EventEmitter<RTCIceCandidate>;
    get messageEmitter(): EventEmitter<Message>;
    createConnection(uuid: string): void;
    close(): void;
    connectionCount(): number;
    connectionsOpened(): number;
    connectionOpened(uuid: string): boolean | undefined;
    private findConnection;
    addIceCandidate(uuid: string, candidate: RTCIceCandidateInit): void;
    createOffer(uuid: string): Promise<RTCSessionDescriptionInit>;
    createAnswer(uuid: string, offer: RTCSessionDescriptionInit): Promise<RTCSessionDescriptionInit>;
    verifyAnswer(uuid: string, answer: RTCSessionDescriptionInit): Promise<void>;
    send(uuid: string, message: ArrayBuffer): boolean;
    sendAndListen(uuid: string, message: ArrayBuffer): Promise<Message>;
    reply(uuid: string, originalMessage: Message, message: ArrayBuffer): boolean;
    replyAndListen(uuid: string, originalMessage: Message, message: ArrayBuffer): Promise<Message>;
    broadcast(message: ArrayBuffer): number;
    broadcastAndListen(message: ArrayBuffer): Promise<Message>[];
    private broadcastSys;
    private systemMessageArrived;
}
